//
//  SetPwdViewController.m
//  SetPassword
//
//  Created by LeadFair on 16/12/8.
//  Copyright © 2016年 Kang. All rights reserved.
//

#import "SetPwdViewController.h"
#import "Masonry.h"
#define kDotCount 6  //密码个数
#define SCREEN_W ([UIScreen mainScreen].bounds.size.width)
#define SCREEN_H ([UIScreen mainScreen].bounds.size.height)

@interface SetPwdViewController ()
{
    NSInteger a1;
    NSInteger b2;
    NSInteger c3;
    NSInteger d4;
    NSInteger e5;
    NSInteger f6;
}

@property (nonatomic,strong) UIButton *downBtn;
/**
 *  密码提示
 */
@property (nonatomic,strong) UILabel *pwdPromptLbl;

@property (nonatomic,assign) NSInteger pwdIndex;

@property (nonatomic,strong) UIImageView *pwdImgView;
/**
 *  用于存放黑色的点点
 */
@property (nonatomic,strong) NSMutableArray *dotArray;
/**
 *  用于存放键盘数字
 */
@property (nonatomic,strong) NSMutableArray *keyNumArray;

@property (nonatomic,strong) NSString *pwdStr;

@end

@implementation SetPwdViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    self.view.backgroundColor = [UIColor lightGrayColor];
    
    self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc]initWithImage:[UIImage imageNamed:@"jiantou_return"] style:UIBarButtonItemStylePlain target:self action:@selector(backHandle)];
    
    _pwdIndex = 0;
    a1 = 0,
    b2 = 0,
    c3 = 0,
    d4 = 0,
    e5 = 0,
    f6 = 0;
    [self createUI];

    
}

- (void)createUI{
    
    
    
    NSInteger pwdW = ( SCREEN_W - 2 ) / 3;
    NSInteger pwdH = pwdW * 0.46;
    
    UIView *kbView = [[UIView alloc] init];
    kbView.backgroundColor = [UIColor lightTextColor];
    [self.view addSubview:kbView];
    [kbView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.bottom.equalTo(self.view);
        make.height.offset(pwdH * 4 + 3);
    }];
    
    
    for (int i = 0; i < 12; i++) {
        
        if (i < 9) {
            UIButton *btn = [[UIButton alloc] initWithFrame:CGRectMake(i % 3 * (pwdW + 1), i / 3 *(pwdH + 1), pwdW, pwdH)];
            [kbView addSubview:btn];
            btn.tag = 10000 + i + 1;
            btn.titleLabel.font = [UIFont boldSystemFontOfSize:22];
            [btn setTitle:[NSString stringWithFormat:@"%d",i + 1] forState:UIControlStateNormal];
            [btn setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
            btn.backgroundColor = [UIColor whiteColor];
            [btn addTarget:self action:@selector(numberClickAction:) forControlEvents:UIControlEventTouchUpInside];
            [self.keyNumArray addObject:btn];
        }
        if (i == 10) {
            UIButton *btn = [[UIButton alloc] initWithFrame:CGRectMake(pwdW + 1, 3 * (pwdH + 1), pwdW, pwdH)];
            [kbView addSubview:btn];
            btn.tag = 10000;
            btn.titleLabel.font = [UIFont boldSystemFontOfSize:22];
            [btn setTitle:@"0"forState:UIControlStateNormal];
            [btn setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
            btn.backgroundColor = [UIColor whiteColor];
            [btn addTarget:self action:@selector(numberClickAction:) forControlEvents:UIControlEventTouchUpInside];
            [self.keyNumArray addObject:btn];
        }
        
        if(i == 11){
            
            UIButton *btn = [[UIButton alloc] initWithFrame:CGRectMake(2 * (pwdW + 1), 3 * (pwdH + 1), pwdW, pwdH)];
            btn.tag = 10000 + 11;
            [kbView addSubview:btn];
            [btn setImage:[UIImage imageNamed:@"delete_btn"] forState:UIControlStateNormal];
            [btn addTarget:self action:@selector(numberClickAction:) forControlEvents:UIControlEventTouchUpInside];
            btn.enabled = false;
            [self.keyNumArray addObject:btn];
        }
    }
    
    NSInteger showH = (SCREEN_W - 30) * 0.58;
    
    UIView *showPwdView = [[UIView alloc] init];
    showPwdView.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:showPwdView];
    
    [showPwdView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.bottom.equalTo(kbView.mas_top).offset(-70);
        make.left.equalTo(self.view.mas_left).offset(15);
        make.right.equalTo(self.view.mas_right).offset(-15);
        make.height.offset(showH);
    }];
    
    NSInteger pwdImgH = (SCREEN_W - 80 ) / 6;
    _pwdImgView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"pwdInput"]];
    [showPwdView addSubview:_pwdImgView];
    [_pwdImgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo (showPwdView.mas_top).offset(showH * 0.23);
        make.left.equalTo(showPwdView.mas_left).offset(25);
        make.right.equalTo(showPwdView.mas_right).offset(-25);
        make.height.offset(pwdImgH);
    }];
    
    //小黑点
    for (int i = 0; i < kDotCount; i++) {
        UIImageView  *dotView = [[UIImageView alloc] initWithFrame:CGRectMake((pwdImgH - 10) / 2 + pwdImgH * i, (pwdImgH -10) / 2, 10, 10)];
        dotView.image = [UIImage imageNamed:@"small_Black"];
        
        dotView.hidden = YES; //先隐藏
        [_pwdImgView addSubview:dotView];
        //把创建的黑色点加入到数组中
        [self.dotArray addObject:dotView];
    }
    
    _pwdPromptLbl = [[UILabel alloc] init];
    _pwdPromptLbl.text = @"请输入新的密码";
    _pwdPromptLbl.font = [UIFont systemFontOfSize:20];
    _pwdPromptLbl.textColor = [UIColor lightGrayColor];
    [showPwdView addSubview:_pwdPromptLbl];
    
    [_pwdPromptLbl mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(_pwdImgView.mas_bottom).offset(20);
        make.centerX.equalTo(_pwdImgView);
    }];
    
    UILabel *pLbl = [[UILabel alloc] init];
    pLbl.text = @"* 密码为6位数字";
    //    _pwdPromptLbl.font = [UIFont systemFontOfSize:20];
    pLbl.textColor = [UIColor lightGrayColor];
    [showPwdView addSubview:pLbl];
    
    [pLbl mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(_pwdPromptLbl.mas_bottom).offset(10);
        make.centerX.equalTo(_pwdImgView);
    }];
    
    
}

#pragma mark - 点击数字按钮
- (void)numberClickAction:(UIButton *)button{
    //    NSLog(@"点击：%ld",button.tag - 10000);
    //    ((UIImageView *)[self.dotArray objectAtIndex:i]).hidden = false;
    for (UIImageView *dotView in self.dotArray) {
        dotView.hidden = YES;
    }
    
    
    if (button.tag - 10000 < 11) {
        _pwdIndex ++;
        
        
        for (int i = 0; i < _pwdIndex; i++) {
            ((UIImageView *)[self.dotArray objectAtIndex:i]).hidden = false;
        }
        ((UIButton *)[self.keyNumArray objectAtIndex:10]).enabled = true;
        /**
         *  存储点击的数字
         */
        if (_pwdIndex == 1) {
            a1 = button.tag - 10000;
            NSLog(@"a1:%ld",a1);
        }else if(_pwdIndex == 2){
            b2 = button.tag - 10000;
            NSLog(@"b2:%ld",b2);
        }else if(_pwdIndex == 3){
            c3 = button.tag - 10000;
            NSLog(@"c3:%ld",c3);
        }else if(_pwdIndex == 4){
            d4 = button.tag - 10000;
            NSLog(@"d4:%ld",d4);
        }else if(_pwdIndex == 5){
            e5 = button.tag - 10000;
            NSLog(@"e5:%ld",e5);
        }else if(_pwdIndex == 6){
            f6 = button.tag - 10000;
            NSLog(@"f6:%ld",f6);
        }
        
    }else{
        _pwdIndex --;
        for (int i = 0; i < _pwdIndex; i++) {
            ((UIImageView *)[self.dotArray objectAtIndex:i]).hidden = false;
        }
        
        for (int i = 0; i < 10; i++) {
            ((UIButton *)[self.keyNumArray objectAtIndex:i]).enabled = true;
        }
    }
    
    if (_pwdIndex == 6) {
        
        for (int i = 0; i < 10; i++) {
            ((UIButton *)[self.keyNumArray objectAtIndex:i]).enabled = false;
        }
        ((UIButton *)[self.keyNumArray objectAtIndex:10]).enabled = true;
        
        _pwdStr = [NSString stringWithFormat:@"%ld%ld%ld%ld%ld%ld",a1,b2,c3,d4,e5,f6];
        
        [self setSuccessBackHandle];
        
        
    }else if(_pwdIndex == 0){
        ((UIButton *)[self.keyNumArray objectAtIndex:10]).enabled = false;
        for (int i = 0; i < 10; i++) {
            ((UIButton *)[self.keyNumArray objectAtIndex:i]).enabled = true;
        }
    }
}


- (NSMutableArray *)dotArray{
    if (_dotArray == nil) {
        _dotArray= [NSMutableArray array];
    }
    return _dotArray;
}

- (NSMutableArray *)keyNumArray{
    if (_keyNumArray == nil) {
        _keyNumArray= [NSMutableArray array];
    }
    return _keyNumArray;
}

//设置完成跳转
- (void)setSuccessBackHandle{
    if (_successBlock) {
        _successBlock(_pwdStr);
    }
    
    [self.navigationController popViewControllerAnimated:YES];
}

//cancel item
- (void)backHandle
{
    if (_cancelBlock) {
        _cancelBlock();
    }
    
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
